# Latest commit on Dec 20 2015: 5ad7cd5 - preparing tarball:
# git clone https://github.com/openwrt/mt76.git
# git archive 

%global	module	76
%global pname mt%{module}

Name:		dkms-%{pname}
Version:	0.1.0
Release:	%mkrel 6
Source0:	%{pname}xx-%{version}.tar.xz
License:	GPLv2
Group:		System/Kernel and hardware
URL:		https://github.com/openwrt/mt76.git
Summary:	dkms package for Mediatek MT76xx + U Wifi's
BuildRoot:	%{_tmppath}/%{name}-%{version}-buildroot

##Patch0:		mt76xx-beacon-make.patch
Patch1:		mt76xx-0.1.0-Makefile-k5.6+.patch
Patch2:		mt76-agg-rx.patch

Provides:	%{name}-%{version}
Provides:	kmod(%{pname}.ko) = %{version}
Suggests:	mt-firmware
Requires(post):		dkms
Requires(preun):	dkms

Obsoletes:	dkms-%{pname} < %{version}-%{release}


%description
mac80211 driver for MediaTek MT76x2e, MT7603, MT7628 and MT7688, 
old:
CHIPSET supported:
mt7612u mt7662u mt7632u
DEVICES:
{ USB_DEVICE(0x0b05, 0x17eb) }ASUS USB AC 55 */
{ USB_DEVICE(0x0b05, 0x180b) },	/*  ASUS USB N53 B1 */
{ USB_DEVICE(0x7392, 0xb711) },	/*  Edimax EW 7722 UAC */
{ USB_DEVICE(0x0846, 0x9053) },	/*  Netgear A6210 */
{ USB_DEVICE(0x057c, 0x8503) },	/*  AVM FRITZ!WLAN USB Stick AC 860 */
{ USB_DEVICE(0x045e, 0x02e6) },	/*  Microsoft XBox One Wireless Adapter */
{ USB_DEVICE(0x0e8d, 0x761b) }, /*  AUKEY USB WiFi Adapter AC1200 *
::from README.md on source::
Driver for 802.11ac USB Adapter with MT7612U chipset
STA, AP and Monitor Modes are possible
Current setting for this driver is APSTA mode as default.
STA mode is working fine
AP mode can crash your kernel if you call iwconfig after module loading

You need to install the firmware blobs ( edited: mt7662 fw included)

At least v4.2 is needed to compile this module
sorry people with older kernels, the code is removed.

This driver is currently under heavy development.

Tested on X86_64 platform(s) only,
+++

%package -n mt-firmware
Summary: firmware for mt76xx drivers
%description -n mt-firmware
firmware for MediaTek MT76x2e, MT7603, MT7628 and MT7688 MT7615e

%prep
%setup -qn %{pname}xx-%{version}
find -type f -exec chmod 0644 {} \;

%apply_patches

%install
%__rm -rf %{buildroot}
%__install -dm755 %{buildroot}%{_usrsrc}/%{pname}xx-%{version}-%{release}
%__cp -a ./* %{buildroot}%{_usrsrc}/%{pname}xx-%{version}-%{release}
%__rm -f %{buildroot}%{_usrsrc}/%{pname}xx-%{version}-%{release}/{CONTRIBUTORS.md,LICENSE,README.md}
%__cat <<EOF > %{buildroot}%{_usrsrc}/%{pname}xx-%{version}-%{release}/dkms.conf
PACKAGE_NAME="%{pname}"
PACKAGE_VERSION="%{version}-%{release}"
MAKE[0]="'make' SKIP_STACK_VALIDATION=1 all"
BUILT_MODULE_NAME[0]="mt76"
DEST_MODULE_LOCATION[0]="/kernel/3rdparty/%{pname}xx"
BUILT_MODULE_NAME[1]="mt76-usb"
DEST_MODULE_LOCATION[1]="/kernel/3rdparty/%{pname}xx"
BUILT_MODULE_NAME[2]="mt76x02-lib"
DEST_MODULE_LOCATION[2]="/kernel/3rdparty/%{pname}xx"
BUILT_MODULE_NAME[3]="mt76x02-usb"
DEST_MODULE_LOCATION[3]="/kernel/3rdparty/%{pname}xx"
BUILT_MODULE_NAME[4]="mt7603e"
BUILT_MODULE_LOCATION[4]="mt7603"
DEST_MODULE_LOCATION[4]="/kernel/3rdparty/%{pname}xx"
BUILT_MODULE_NAME[5]="mt76x0-common"
BUILT_MODULE_LOCATION[5]="mt76x0"
DEST_MODULE_LOCATION[5]="/kernel/3rdparty/%{pname}xx"
BUILT_MODULE_NAME[6]="mt76x0e"
BUILT_MODULE_LOCATION[6]="mt76x0"
DEST_MODULE_LOCATION[6]="/kernel/3rdparty/%{pname}xx"
BUILT_MODULE_NAME[7]="mt76x0u"
BUILT_MODULE_LOCATION[7]="mt76x0"
DEST_MODULE_LOCATION[7]="/kernel/3rdparty/%{pname}xx"
BUILT_MODULE_NAME[8]="mt76x2-common"
BUILT_MODULE_LOCATION[8]="mt76x2"
DEST_MODULE_LOCATION[8]="/kernel/3rdparty/%{pname}xx"
BUILT_MODULE_NAME[9]="mt76x2e"
BUILT_MODULE_LOCATION[9]="mt76x2"
DEST_MODULE_LOCATION[9]="/kernel/3rdparty/%{pname}xx"
BUILT_MODULE_NAME[10]="mt76x2u"
BUILT_MODULE_LOCATION[10]="mt76x2"
DEST_MODULE_LOCATION[10]="/kernel/3rdparty/%{pname}xx"
AUTOINSTALL="yes"
CLEAN="make clean"
EOF

### firmware-inst
%__install -dm755 %{buildroot}/lib/firmware/mediatek
mv %{buildroot}%{_usrsrc}/%{pname}xx-%{version}-%{release}/firmware/* %{buildroot}/lib/firmware/mediatek/
# remove firmware present in linux-firmware package
rm -f %{buildroot}/lib/firmware/mediatek/mt7610e.bin


%post -n %{name}
/usr/sbin/dkms --rpm_safe_upgrade add -m %{pname}xx -v %{version}-%{release}
/usr/sbin/dkms --rpm_safe_upgrade build -m %{pname}xx -v %{version}-%{release}
/usr/sbin/dkms --rpm_safe_upgrade install -m %{pname}xx -v %{version}-%{release}
true
/sbin/modprobe %{pname}

if [ "$1" = 1 ]; then
/sbin/modprobe %{pname} >/dev/null 2>&1
echo "Reloading network configuration ... "
/sbin/service network reload >/dev/null 2>&1
echo "%{pname}" >> /etc/modprobe.preload
fi

%preun -n %{name}
/usr/sbin/dkms --rpm_safe_upgrade remove -m %{pname}xx -v %{version}-%{release} --all
true
/sbin/rmmod %{pname}

if [ "$1" = 0 ]; then
/sbin/rmmod %{pname} >/dev/null 2>&1
echo "Reloading network configuration ... "
/sbin/service network reload >/dev/null 2>&1
sed -i '/%{pname}/ d' /etc/modprobe.preload
fi
## remove module-destdir just if it empty after dkms remove,(user's only deinstall after testing)... ##
## so prevent we not have empty folders in kernel-tree for next mklivecd ##
if [ ! -f /lib/modules/*/kernel/3rdparty/%{pname}xx/* ]; then
rm -r /lib/modules/*/kernel/3rdparty/%{pname}xx >/dev/null 2>&1
fi

%clean
%__rm -rf %{buildroot}

%files
#%doc README.md
##CONTRIBUTORS.md LICENSE 
%defattr(-,root,root,-)
%{_usrsrc}/%{pname}xx-%{version}-%{release}

%files -n mt-firmware
%defattr(-,root,root,-)
/lib/firmware/mediatek/*


%changelog
* Thu Apr 09 2020 onkelho <oh.quait at gmail.com> - 0.1.0-6pclos2020
- rebuild  -fix kernel-5.6+++

* Thu Feb 20 2020 onkelho <oh.quait at gmail.com> - 0.1.0-5pclos2020
- rebuild updates

* Sun Feb 09 2020 onkelho <oh.quait at gmail.com> - 0.1.0-4pclos2020
- rebuild

* Mon Jul 15 2019 onkelho <oh.quait at gmail.com> 0.1.0-3pclos2018
- rebuild

* Mon Jul 08 2019 onkelho <oh.quait at gmail.com> 0.1.0-2pclos2019
- rebuild

* Fri Jul 05 2019 onkelho <oh.quait at gmail.com> 0.1.0-1pclos2019
- new , switched to openwrt and aur

